# リスト2-1  アイスクリームの支出と気温のグラフ
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
import pandas as pd
import matplotlib.pyplot as plt
# 2016年　一世帯当たりアイスクリーム支出金額（一般社団法人日本アイスクリーム協会）
#   　https://www.icecream.or.jp/data/expenditures.html
icecream = pd.DataFrame(\
  [[1, 464, 10.6], [2, 397, 12.2], [3, 493, 14.9], [4, 617, 20.3], \
   [5, 890, 25.2], [6, 883, 26.3], [7, 1292, 29.7], [8, 1387, 31.6], \
   [9, 843, 27.7], [10, 621, 22.6], [11, 459, 15.5], [12, 561, 13.8]], \
                        columns=['月', '月間アイスクリーム支出', '平均気温'])
#
# 図A　DF.plotで折れ線が描ける
icecream['月間アイスクリーム支出'].plot()
plt.show()

# 図B　表タイトルや軸ラベルを付ける
icecream['月間アイスクリーム支出'].plot()
plt.title('2016年の一世帯当たりアイスクリーム支出')
plt.xlabel('月')  # plt.xlabel(icecream.columns[0])
plt.ylabel('月間アイスクリーム支出（円）')  # plt.ylabel(icecream.columns[1])
plt.show()

# 図C　DF.plotではなくてplt.plot(DF)で描く
plt.plot(icecream[['月間アイスクリーム支出']])
plt.title('2016年の一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('月間アイスクリーム支出（円）')
plt.show()

# 図D　2つのデータを描き、凡例を付ける
icecream[['月間アイスクリーム支出', '平均気温']].plot(legend=True)
plt.title('2016年の気温と一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('月間アイスクリーム支出（円）・平均気温')
plt.show()


# リスト2-2  アイスクリームの支出と気温のグラフ  # リスト2-1から続けて実行
#
# 図E　同じデータで棒グラフ（bar）を描く
icecream['月間アイスクリーム支出'].plot(kind='bar')
plt.title('2016年の一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('月間アイスクリーム支出（円）')
plt.show()

# 図F　棒グラフで2つのデータを描く
icecream[['月間アイスクリーム支出', '平均気温']].plot(kind='bar', colormap='Greys', \
    edgecolor='k')
plt.title('2016年の気温と一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('月間アイスクリーム支出（円）')
plt.show()
