# リスト2-3　アイスクリームの支出と気温のグラフ
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
import pandas as pd
import matplotlib.pyplot as plt
# 2016年　一世帯当たりアイスクリーム支出金額（一般社団法人日本アイスクリーム協会）
# https://www.icecream.or.jp/data/expenditures.html
icecream = pd.DataFrame(\
    [[1, 464, 10.6], [2, 397, 12.2], [3, 493, 14.9], [4, 617, 20.3], \
    [5, 890, 25.2], [6, 883, 26.3], [7, 1292, 29.7], [8, 1387, 31.6], \
    [9, 843, 27.7], [10, 621, 22.6], [11, 459, 15.5], [12, 561, 13.8]], \
                        columns=['月', '月間アイスクリーム支出', '平均気温'])

# 図G　気温-アイスクリーム支出の散布図を描く
icecream.plot.scatter(x='平均気温', y='月間アイスクリーム支出')
plt.title('2016年の気温と一世帯当たりアイスクリーム支出')
plt.xlabel('平均気温')
plt.ylabel('月間アイスクリーム支出（円）')
plt.show()

# 図H　バブルチャートを描く
icecream.plot.scatter(x='月', y='平均気温', s=icecream['月間アイスクリーム支出'] * 0.5)
plt.title('2016年の気温と一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('平均気温')
plt.show()
