# リスト2-4　アイスクリームの支出と気温のグラフ
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
import pandas as pd
import matplotlib.pyplot as plt
# 2016年　一世帯当たりアイスクリーム支出金額（一般社団法人日本アイスクリーム協会）
# https://www.icecream.or.jp/data/expenditures.html
icecream = pd.DataFrame(\
    [[1, 464, 10.6], [2, 397, 12.2], [3, 493, 14.9], [4, 617, 20.3], \
     [5, 890, 25.2], [6, 883, 26.3], [7, 1292, 29.7], [8, 1387, 31.6], \
     [9, 843, 27.7], [10, 621, 22.6], [11, 459, 15.5], [12, 561, 13.8]], \
                          columns=['月', '月間アイスクリーム支出', '平均気温'])
# 図I　月-気温-アイスクリーム支出を点の色で描く
icecream.plot.scatter(x='月', y='平均気温', s=81, \
    c=icecream['月間アイスクリーム支出'] * 0.5, cmap='bwr')
plt.title('2016年の気温と一世帯当たりアイスクリーム支出')
plt.xlabel('月')
plt.ylabel('平均気温')
plt.show()

# 図J　アイスクリーム支出との相関関係をヒートマップで描く
import seaborn as sns
nissho = [201.5, 160.1, 161.9, 149.2, 204.9, 139.1, 143.7, 156.5, 79.4, 119.6, \
          132.1, 193.7]
fusoku = [2.4, 2.9, 2.8, 3.3, 3.4, 2.9, 2.7, 3.1, 2.4, 2.4, 2.5, 2.6]
nissharyou = [9.9, 11.4, 13.5, 14.9, 19.3, 15.0, 15.3, 15.8, 10.0, 9.6, 8.2, 9.1]
icecream['日照時間'] = nissho
icecream['平均風速'] = fusoku
icecream['全天日射量'] = nissharyou
corrcoef = icecream[['平均気温', '日照時間', '平均風速', '全天日射量', '月間アイスクリーム支出']].corr()
sns.heatmap(corrcoef, vmax=1, vmin=-1, center=0)
plt.show()
