# リスト3-10  ケンドールのτをscipy.stats.kendalltauによって計算するプログラム例
# -*- coding: utf-8 -*-
# 分割表からデータを生成し、それをscipy.stats.kendalltauによって計算する例
import numpy as np
import scipy.stats as st
d = np.array([ [ 91, 284, 22 ],
    [ 35, 106, 6 ],
    [ 52, 55, 10 ] ] )
# dの分割表に従うデータを生成するループ
z = [[[i, j]] * (d[i, j]) for i in range(3) for j in range(3)]
# zを二重リストから平らなリストに変換する
tdata = []
for v in z:
    tdata.extend(v)
# kendalltauの入力はxの値のベクトルとyの値のベクトルなのでそれに合わせる
x = [u[0] for u in tdata]
y = [u[1] for u in tdata]
# kencalltauを呼び出す。結果はtauとp値が返る
tau, p_value = st.kendalltau(x, y)
print('tau', tau.round(4), 'p_value', p_value)
# 出力結果は
# 書籍では tau -0.1101 p_value 2.29971067849e-05
# numpy更新により  tau -0.1101 p_value 0.0025006047521086224
