# リスト3-4  アイスクリーム支出と気温から回帰方程式を求める（StatsModelsのOLSを使用）
# -*- coding: utf-8 -*-
# アイスクリーム支出の回帰分析　StatsModelsのOLSを用いる
import numpy as np
import pandas as pd
import statsmodels.api as sm  # 回帰分析はStatsModelsパッケージを利用する
icecream = [[1, 464], [2, 397], [3, 493], [4, 617], [5, 890], [6, 883], \
    [7, 1292], [8, 1387], [9, 843], [10, 621], [11, 459], [12, 561]]
temperature = [[1, 10.6], [2, 12.2], [3, 14.9], [4, 20.3], [5, 25.2], [6, 26.3], \
    [7, 29.7], [8, 31.6], [9, 27.7], [10, 22.6], [11, 15.5], [12, 13.8]]
x = np.array([u[1] for u in temperature])
y = np.array([u[1] for u in icecream])
# 切片計算のため、xに定数列を1列加えてからモデルを作る
model = sm.OLS(y, sm.add_constant(x))
results = model.fit()
print(results.summary())
print('p-values\n', results.pvalues)
b, a = results.params
print('a', a.round(4), 'b', b.round(4))
