# リスト4-6  フィッシャーのアヤメのデータの15点を教師に使ったk-近傍法
import numpy as np
from sklearn.datasets import load_iris
from sklearn.neighbors import NearestNeighbors
import pandas as pd
iris = load_iris()
species = ['Setosa', 'Versicolour', 'Virginica']
irispddata = pd.DataFrame(iris.data, columns=iris.feature_names)
# 別になっているtargetデータ（アヤメの種類）をirispddataに追加する
irispddata['target'] = iris.target
# それぞれの種類のデータを5点ずつ取り出して結合し、学習用（教師）データとする
iris0 = irispddata[irispddata['target'] == 0][:5]
iris1 = irispddata[irispddata['target'] == 1][:5]
iris2 = irispddata[irispddata['target'] == 2][:5]
irisall = pd.concat([iris0, iris1, iris2])
# 新しいデータ（推定テスト用データ）を1点作る（最後のデータにした）
newiris = irispddata[['sepal length (cm)','sepal width (cm)', \
    'petal length (cm)','petal width (cm)']][-1:]
nb = NearestNeighbors(n_neighbors=3, algorithm='ball_tree')
nbfit = nb.fit(irisall[['sepal length (cm)','sepal width (cm)', \
    'petal length (cm)','petal width (cm)']].values)
distances, indices = nbfit.kneighbors(newiris[['sepal length (cm)', \
    'sepal width (cm)','petal length (cm)','petal width (cm)']])
print('indices\n', indices)
print('distances\n', distances)
