# リスト5-2  Orange 3を使ったアソシエーション分析の例
import Orange
# frequent_itemset, assoiation_rules, rules_statsを取り込み
from orangecontrib.associate.fpgrowth import *
# csv_readの代わりにOrange内の関数を使う
data = Orange.data.Table("market-basket-kanji.basket")
# One Hot変換する。Orange内のOneHot.encodeを使う
X, mapping = OneHot.encode(data, include_class=True)
# Xがデータ、mappingが対応表
# supportが0.4以上のitem・itemsetだけを取り出す
itemsets = dict(frequent_itemsets(X, 0.4))

class_items = {item for item, var, _ in OneHot.decode(mapping, data, mapping)}
# One Hotの逆変換をして名前のリストを取り出す。戻り値は {0, 1, 2, 3, 4, 5}
rules = [(ante, cons, supp, conf)
    # confidence > 0.7
    for ante, cons, supp, conf in association_rules(itemsets, 0.7)
        if len(cons) == 1 and cons & class_items]
# itemsetに対してassociation_rulesを最小信頼度0.4で適用する。
# 結果を(前提, 結論, 支持, 信頼)のリストにする

names = {item: '{}'.format(var.name)
# 商品名と内部IDの対応表を用意
    for item, var, val in OneHot.decode(mapping, data, mapping)}

for ante, cons, supp, conf in rules:
    print(','.join(names[i] for i in ante), '-->',
        names[next(iter(cons))],
        '(supp: {}, conf: {})'.format(supp/len(X), conf))  # 出力rulesを表示

stat = rules_stats(rules, itemsets, len(X))  # rules_statsで他の指標も計算する
for ante, cons, supp, conf, cover, stren, lift, levelage in stat:
    print(','.join(names[i] for i in ante), '-->',
        names[next(iter(cons))],
        '(supp: {}, conf: {}, cover; {}, stren; {}, lift: {}, levelage: {})'. \
            format(supp/len(X), conf, cover, stren, lift, levelage))
