# リスト5-3  アンケート調査結果のアソシエーション分析の例
import pandas as pd
from rpy2.robjects import r, pandas2ri
pandas2ri.activate()
import rpy2.robjects as ro
import rpy2.robjects.packages as rpackages
utils = rpackages.importr('utils')  # urilsパッケージをR上でimportr
utils.chooseCRANmirror(ind=1)  # ダウンロードサイトをind=1に指定
# パッケージarulesをダウンロード、初回のみ必要
utils.install_packages(ro.StrVector(['arules']))

r('library(arules)')  # R上でlibrary(arules)を実行　arulesをR上にロード
r('data(Income)')  # R上でdata(Income)を実行　データIncomeを抽出
# R上でm <- as(Income, 'matrix')を実行
# これによってIncomeデータをmatrix形式に変換し変数mに代入する
r("m <- as(Income, 'matrix')")
m = r['m']  # R側の変数mをPython側の変数mに読み込む
r("labels <- Income@itemInfo['labels']")
             # R上でIncomeのitemInfo['labels']を抽出
labels = r['labels']  # Python側の変数labelsへ読み込む
print('labels\n',labels)
df = pd.DataFrame(m, columns=labels)

# ここからmlxtendによる処理を開始
from mlxtend.preprocessing import TransactionEncoder
from mlxtend.frequent_patterns import apriori

frequent_itemsets = apriori(df, min_support=0.1, \
         use_colnames=True)  # min_supportは0.1にしている
from mlxtend.frequent_patterns import association_rules
 
rules0 = association_rules(frequent_itemsets, metric="confidence", \
         min_threshold=0.8)  # min_thresholdは0.8にしている

s = 'income=$40,000+'
f = lambda v: (s,) in v
result = rules0[rules0['consequents'].map(f)]
print('results sorted by support\n', result.sort_values('support', \
    ascending=False)[:9])
