# リスト6-2  国際線乗客数の自己相関・偏自己相関を求める
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
# 基本のライブラリを読み込む
import numpy as np
import pandas as pd
from matplotlib import pylab as plt
# デフォルトでグラフを横長にする設定
from matplotlib.pylab import rcParams
rcParams['figure.figsize'] = 15, 6
import statsmodels.api as sm

# https://stat.ethz.ch/R-manual/R-devel/library/datasets/html/AirPassengers.html
from rpy2.robjects import r, pandas2ri
pandas2ri.activate()
# AirPassengersデータはnumpy.arrrayの形で来る
df = pd.DataFrame(r['AirPassengers'], columns=['Airline Passengers'])

df.plot(figsize=(15, 6))  # プロット。図を横長に15×6インチにする

# ラグが40までの自己相関
print('自己相関', sm.tsa.stattools.acf(df, unbiased=True, nlags=40))
sm.graphics.tsa.plot_acf(df, unbiased=True, lags=40)
plt.show()

# ラグが40までの偏自己相関
print('偏自己相関', sm.tsa.stattools.pacf(df, nlags=40, method='ols'))
sm.graphics.tsa.plot_pacf(df, lags=40)
plt.show()
