# リスト6-3   国際線乗客数の時系列をトレンド・周期変動・残渣に分解する
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
import numpy as np
import pandas as pd
from matplotlib import pylab as plt

# グラフの大きさを変更する
from matplotlib.pylab import rcParams
rcParams['figure.figsize'] = 15, 15

# 統計モデル
import statsmodels.api as sm

# https://stat.ethz.ch/R-manual/R-devel/library/datasets/html/AirPassengers.html
from rpy2.robjects import r, pandas2ri
pandas2ri.activate()
# AirPassengersデータはnumpy.arrrayの形で来る
df = pd.DataFrame(r['AirPassengers'], columns=['Airline Passengers'])

seasonal = sm.tsa.seasonal_decompose(df['Airline Passengers'].values, freq=12)
seasonal.plot()
plt.show()
