# リスト7-1  igraphによるグラフ定義と描画の例
from igraph import *
# R igraphのグラフをきれいに表示させる
# python-igraph Manual Tutorial
# http://igraph.org/python/doc/tutorial/tutorial.html
# 隣接行列adjをPythonのリストとして定義する
adj = [[0, 1, 1, 0], [1, 0, 1, 0],
       [0, 1, 0, 1], [1, 0, 0, 0]]
g = Graph.Adjacency(adj)  # 行列データadjを持つグラフを生成し、gとする
g.vs["name"] = ['1', '2', '3', '4']  # gの4つのノードの名前を付ける
g.vs["label"] = ['1', '2', '3', '4']  # gの4つのノードの表示用ラベルを付ける
g.vs["color"] = ['white', 'white', 'white', 'white']  # ノードの色を指定
# 6つの辺を直線で表示する
g.es["curved"] = [False, False, False, False, False, False, False]
layout = g.layout("circle")  # 表示レイアウトをcircleにする
# 表示する。Jupyter NotebookやiPythonでinlineに表示する
plot(g, bbox=(400, 400), inline=True)

print(g.get_edgelist())  # グラフgを辺リストに変換して表示する
