# リスト7-5  重み付きグラフの最短経路長の計算
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
# 下記ではファイルlesmis.gmlをダウンロードしてあるものと想定しています
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from igraph import *
g = Graph.Read_GML('lesmis/lesmis.gml')

g.es['weight'] = g.es['value']  # 辺の重みを元データのvalueにする。weightは重み
    # weightプロパティに値を入れることによって、重み付きグラフになる
print('重み付きグラフか？', g.is_weighted())
df = pd.DataFrame(g.shortest_paths_dijkstra(weights='weight'), \
    columns=g.vs['label'], index=g.vs['label'])
print(df)
print('diameter:', df.max().max())  # dfの最大値を列ごとの最大値の行ごとの最大値で求める
# 列ごとのカウントを足し合わせる
dfp = df.astype(int).apply(pd.value_counts).replace(np.nan, 0).sum(axis=1) / 2
print(dfp)
dfp[1:].plot.bar()  # 長さ0の項を除くため1から始める
plt.title('登場人物間の重み付き距離の頻度分布')
plt.xlabel('重み付き距離')
plt.ylabel('頻度')
plt.show()

