# リスト7-7  中心性の計算プログラム
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
from igraph import *
import urllib.request
import pandas as pd
import numpy as np
x =\
[[0, 1, 0, 1, 0, 0],
 [0, 0, 0, 0, 1, 1],
 [0, 1, 0, 0, 0, 1],
 [1, 0, 1, 0, 0, 0],
 [0, 1, 0, 0, 0, 0],
 [0, 0, 0, 1, 1, 0]]
g = Graph.Adjacency(x)
g.vs['label'] = ['A', 'B', 'C', 'D', 'E', 'F']
# 経路長
print("shortest_path_dijkstra\n", pd.DataFrame(g.shortest_paths_dijkstra(), \
        index=['A','B','C','D','E','F'], columns=['A','B','C','D','E','F']))

# 離心中心性
df2 = pd.DataFrame(g.shortest_paths_dijkstra(), columns=g.vs['label'], \
    index=g.vs['label']).replace(np.inf, np.nan)
print(df2)
print("eccentricity centrality", sorted( zip(g.vs['label'], \
    [1 / u for u in list(g.eccentricity())]), key=lambda x: x[1], \
    reverse=True)[:30])
# 近接中心性
print("closeness", sorted( zip(g.vs['label'], \
    list(g.closeness(mode=OUT, normalized=False))), key=lambda x: x[1], \
    reverse=True)[:30])
print("normalized closeness", sorted( zip(g.vs['label'], \
    list(g.closeness(mode=OUT, normalized=True))), key=lambda x: x[1], \
    reverse=True)[:30])
# 次数中心性
print("degree centrality", sorted( zip(g.vs['label'], \
    [u / (len(g.degree()) - 1) for u in list(g.degree())]), key=lambda x: x[1], \
    reverse=True)[:30])
# 固有ベクトル中心性
print("eigenvalue-based centrality", sorted( zip(g.vs['label'], \
    list(g.evcent())), key=lambda x: x[1], reverse=True)[:30])
# ページランク中心性
print("PageRank", g.pagerank())
# 媒介中心性
print("betweenness", sorted( zip(g.vs['label'], list(g.betweenness())), \
    key=lambda x: x[1], reverse=True)[:30])
