# リスト7-8  Les Miserablesの人物関係グラフのクリーク・コミュニティ分析
#%matplotlib inline  # Jupyter Notebookで実行する場合コメントマーク#を外す
# 下記ではファイルlesmis.gmlをダウンロードしてあるものと想定しています
# クリークとコミュニティの分析の例
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from igraph import *
g = Graph.Read_GML('lesmis/lesmis.gml')  # ファイルの読み込み

g.vs['name'] = g.vs['label']  # gmlファイルではlabelとなっているのでnameにコピー

print('---cliques---------------')
# print('cliques', [g.cliques())  # すべてのクリークを表示したいとき
print('largest cliques', [ [g.vs['name'][v] for v in u] \
for u in list(g.largest_cliques()) ] )  # 名前順でソート
print('maximal cliques', [ [g.vs['name'][v] for v in u] \
for u in list(g.maximal_cliques()) ] )  # 名前順でソート

print('---community-------------')

print('===community edge betweenness===')
d = g.community_edge_betweenness()
print('community edge betweenness', d)
plot(g.community_edge_betweenness())
# print('format', d.format())  # 樹形図をリスト形式で出力

print('===community optimal modularity===')
plot(g.community_optimal_modularity())

print('===community fast greedy===')
print('community fast greedy', g.community_fastgreedy())
plot(g.community_fastgreedy())  # 樹形図をプロットする

print('===community leading eigenvector===')
plot(g.community_leading_eigenvector())

print('===community label propagation===')
plot(g.community_label_propagation())

print('===community multilevel===')
plot(g.community_multilevel())

print('===community info map===')
print('community info map', g.community_infomap())
plot(g.community_infomap())

print('===community spinglass===')
plot(g.community_spinglass())

print('===community walktrap===')
plot(g.community_walktrap())
