# 本ファイルは、第2.3.1節に掲載されているプログラム断片を掲載したものです。
# このままファイル全体を実行しても、正しく実行されません。


import numpy as np
a = np.array([2,3,4])  # リスト[2,3,4]をNumPyの配列に変換する
print(a)   # 結果は [2  3  4]
b =np.array([[2,3,4], [5,6,7]])  # リストのリストを配列に変換する
print(b)
# 結果は2次元の配列（行列）になる
# [[2 3 4]
#  [5 6 7]]



a = np.array([1, 2, 3, 4])
b = np.array([5, 6, 7, 8])
c = a + b
print(c)          # 結果は要素ごとの和 [6  8  10  12]
print(a**2)       # 結果は要素ごとの2乗 [ 1  4  9 16]
print(np.sin(a))  # 結果は [ 0.84147098  0.90929743  0.14112001 -0.7568025 ]
print(a<2)        # 結果は [ True False False False]



a = np.array([1, 2, 3, 4])
b = np.array([5, 6, 7, 8])
print(a * b)  # 結果は [ 5 12 21 32] ← 要素ごとの積
print(a.dot(b))  # 結果は 70 ← ベクトルの内積 1 * 5 + 2 * 6 + 3 * 7 + 4 * 8
print(np.dot(a, b))  # 内積はこう書いてもよい 結果は 70
# 行列の場合
A = np.array([[1, 1], [0, 1]])
B = np.array([[2, 0], [3, 4]])
print(A * B)  # 結果は [[2 0] [0 4]] ← 要素ごとの積
print(A.dot(B))  # 結果は [[5 4] [3 4]] ← この場合は内積np.dot(A, B)と同じ



A = np.array([[1, 2], [3, 4]])
print(A.sum())  # 結果は 10 すべての要素の合計
print(A.max())  # 結果は 4 すべての要素の最大値
print(A.min())  # 結果は 1 すべての要素の最小値
# 軸方向を決めてその方向での合計・最大・最小
print(A.sum(axis=0))  # 結果は [4 6] 縦方向の合計
print(A.sum(axis=1))  # 結果は [3 7] 横方向の合計
print(A.max(axis=0))  # 結果は [3 4] 縦方向の最大値
print(A.max(axis=1))  # 結果は [2 4] 横方向の最大値



A = np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]])
print(A[1, 1])      # 結果は 5 （要素1つのみ）
print(A[1:3, 1])    # 結果は [5 8] （1列で2要素）
print(A[1:3, 0:2])  # 結果は [[4 5] [7 8]] （2行2列で4要素）



a = np.array([1, 2, 3, 4, 5, 6, 7, 8, 9])
b = a.reshape(3, 3) # 3×3に形を変える
print(b)
# 結果は
# [[1 2 3]
# [4 5 6]
# [7 8 9]]
c = b.ravel()    # 平ら（1次元）に形を変える
print(c)
# 結果は [1 2 3 4 5 6 7 8 9]



a = np.array([[1, 2, 3], [4, 5, 6]])
b = a     # Shallow Copyingで名前だけしかコピーされない
b[1, 1] = 100
print(a)
# 結果は
# [[ 1 2 3]
#  [ 4 100 6]]
a = np.array([[1, 2, 3], [4, 5, 6]])
b = a.copy()     # Deep Copyingで実体をコピーする
b[1, 1] = 100
print(a)
# 結果は
# [[1 2 3]
#  [4 5 6]]      # b[1, 1]への変更は影響しない