# 本ファイルは、第2.3.2に掲載されているプログラム断片を掲載したものです。
# このままファイル全体を実行しても、正しく実行されません。


import pandas as pd
import numpy as np
x = [[1, 2], [3, 4]]    # Pythonのリストを作る
nx = np.array(x)        # NumPyの配列に変換する
df1 = pd.DataFrame(x)   # PythonのリストからDataFrameを生成
print(df1)
# 結果は
#    0  1
# 0  1  2
# 1  3  4
df2 = pd.DataFrame(nx)
print(df2)
# 結果は同じで、
#    0  1
# 0  1  2
# 1  3  4



df = pd.DataFrame([[1, 2], [3, 4]], columns=['番号', '長さ'], index=['田中', '山田'])
print(df)
# 結果は
#     番号  長さ
# 田中   1   2
# 山田   3   4



df = pd.DataFrame([[1, 2], [3, 4]], columns=['番号', '長さ'], index=['田中', '山田'])
dfnew = df.rename(columns={'番号': '新番号', '長さ': '個数'}, index={'田中': '渡辺'})
print(dfnew)
# 結果は
#     新番号  個数
# 渡辺    1   2
# 山田    3   4
#
df = pd.DataFrame([[1, 2], [3, 4]], columns=['番号', '長さ'], index=['田中', '山田'])
df.columns = ['新新番号', '点数'] # すべての欄名を変更するとき
df.index = ['Jack', 'Harry'] # すべての列名を変更するとき
print(df)
# 結果は
#        新新番号  点数
# Jack      1      2
# Harry     3      4



df = pd.DataFrame([[1, 2], [3, 4]], columns=['番号', '長さ'], index=['田中', '山田'])
print(df['番号']['山田'])
# 結果は 3
print(df['番号'])   # '番号'の名前を持つ列を取り出す
# 結果は
# 田中    1
# 山田    3
# Name: 番号, dtype: int64



print(df.loc['田中'])
# 出力は
# 番号    1
# 長さ    2
print(df.loc['田中','番号']) # 出力は 1



print(df.iloc[0])
# 出力は
# 番号    1
# 長さ    2
# Name: 田中, dtype: int64
print(df.iloc[0, 0]) # 出力は 1


